require 'thor'
require 'colorize'
require 'doraBox/util/logger'
require 'doraBox/util/file_operator'
require 'doraBox/util/pod_file_helper'

module DoraBox

  class CLI < Thor

    desc "start_modules", "项目启动时首次配置，输入需要修改的模块"
    def start_modules

      modules = FileOperator.get_stdin_modified_modules
      branch_name = FileOperator.get_stdin_branch_name
      PodFileHelper.handle_pod_file(modules,branch_name)
    end

    desc "single moduleName", "修改 podfile 中单个模块的版本依赖"
    def single(module_name)
      config = FileOperator.load_cached_modules_config

      if config
        branch_name = config["branchName"]
        PodFileHelper.handle_pod_file([module_name],branch_name)
      end
    end

  end
end